#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <stdbool.h>
#include "hachage_simple.h"
#include "abr.h"


void init_table (struct table* T, fonction_hachage* H){
   int i = 0;
    for(i=0; i<N;i++){
       (T->tab[i].L) = NIL;
    }
    T->hash = H;
}

void clear_table (struct table* T){
   int i = 0; 
    for(i=0; i<N;i++){
       clear_abr(T->tab[i].L);
    }
}

void enregistrer_table (struct table* T, double d){
    int i;
    i=T->hash(d);
    T->tab[i].L = ajout_abr_rec(i, T->tab[i].L);
}

bool rechercher_table (struct table* T, double d){
   int i;
   i= T->hash(d);
   recherche_abr_rec(i,T->tab[i].L);
}

void imprimer_table (struct table* T){
   int i = 0; 
    for(i=0; i<N;i++){
       imprime_abr(T->tab[i].L);
    } 
}

